#include <pthread.h>
#include <stdlib.h>

typedef struct __counter_t {
  int num_cpu;          // number of cpus
  long long global;             // global count
  pthread_mutex_t glock;  // global lock
  long *local;             // local count (per cpu)
  pthread_mutex_t *llock; // ... and locks
  int threshold;          // update frequency
} counter_t;

void init_counter(counter_t *c, int threshold, int num_cpu);

void update_counter(counter_t * c, int t_id, int amount);

int get_counter_val(counter_t *c);

void sync_counter(counter_t *c);

void destroy_counter(counter_t *c);
