#include "counter.h"
#include <stdio.h>
#include <unistd.h>

#define COUNT_LIMIT 10000000
#define THREADSHOLD 1024

counter_t counter;

void *worker(void *t_id) {
  printf("Thread %d started\n", (int) t_id);
  for (int i = 0; i < COUNT_LIMIT; i++) {
    update_counter(&counter, (int) t_id, 1);
  }
}

int main() {
  long num_cpus = sysconf(_SC_NPROCESSORS_ONLN);
  printf("Number of CPUs: %ld\n", num_cpus);
  pthread_t *threads = malloc(num_cpus * sizeof(pthread_t));
  init_counter(&counter, THREADSHOLD, num_cpus);
  for (int i = 0; i < num_cpus; i++) {
    pthread_create(&threads[i], NULL, worker, (void *) i);
  }
  for (int i = 0; i < num_cpus; i++) {
    pthread_join(threads[i], NULL);
  }

  sync_counter(&counter);
  printf("Counter value: %d\n", get_counter_val(&counter));
  destroy_counter(&counter);

  return 0;
}
